package net.minecraft.src;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

import net.minecraft.client.Minecraft;

public class ItemNameplate extends Item
{
    public static String texturePng = "/Nameplate/icon_nameplate.png";

    public ItemNameplate(int id)
    {
        super(id);
        this.maxStackSize = 64;
    }

    public ItemStack onItemRightClick(ItemStack item, World world, EntityPlayer player)
    {
        Minecraft minecraft = ModLoader.getMinecraftInstance();

        if (minecraft.objectMouseOver == null)
        {
            return item;
        }
        /*
        else if (minecraft.objectMouseOver.vertexPositions != EntityPlayer.spawnChunk)
        {
            return item;
        }
        */
        else if(mod_Nameplate.EntityNameable(minecraft.objectMouseOver.entityHit))
        {
	    	if(! mod_Nameplate.isJPInputEnable)
	    	{
	            ModLoader.openGUI(player, new GuiPetRename(world, player, (EntityLiving)minecraft.objectMouseOver.entityHit, item));
	    	}
	    	else
	    	{
		        try
		        {
		        	Class guiClass = Class.forName("GuiPetRenameJP");
		            if(guiClass != null)
		            {
		            	Class<?>[] types = { World.class, EntityPlayer.class, EntityLiving.class, ItemStack.class };
		            	Constructor constructor;
		            	try {
		            		constructor = guiClass.getConstructor(types);
		            	} catch (SecurityException e) {
		            		throw new RuntimeException(e);
		            	} catch (NoSuchMethodException e) {
		            		throw new RuntimeException(e);
		            	}
		            	Object[] args = { world, player, (EntityLiving)minecraft.objectMouseOver.entityHit, item };
		            	GuiScreen gui;
		            	try {
		            		gui = (GuiScreen)(constructor.newInstance(args));
		            	} catch (IllegalArgumentException e) {
		            		throw new RuntimeException(e);
		            	} catch (InstantiationException e) {
		            		throw new RuntimeException(e);
		            	} catch (IllegalAccessException e) {
		            		throw new RuntimeException(e);
		            	} catch (InvocationTargetException e) {
		            		throw new RuntimeException(e);
		            	}
			            ModLoader.openGUI(player, gui);
		            }
		        }
		        catch (Exception var2) { }
	    	}

            if(minecraft.objectMouseOver.entityHit instanceof EntityTameable)
            {
                boolean isSitting = ((EntityTameable)minecraft.objectMouseOver.entityHit).isSitting();
                //System.out.println(String.format("isSitting=%s", new Object[] { Boolean.toString(isSitting) }));
                ((EntityTameable)minecraft.objectMouseOver.entityHit).setSitting(!isSitting);
            }

            return item;
        }

        return item;
    }
    public String getItemNameIS(ItemStack itemstack)
    {
        return "item.nameplate";
    }
}
